/*
 * AEvent.h
 *
 *  Created on: Dec 28, 2016
 *      Author: daria
 */

#ifndef DATACLASSES_AEVENT_H_
#define DATACLASSES_AEVENT_H_

#include <iostream>
#include <fstream>
#include <iomanip>
#include <sstream>

#include "TError.h"
#include "TString.h"
#include "TTree.h"
#include "TFile.h"
//#include "TMath.h"


#include "RawEvent.h"

#define NCELLS 1024

using std::cout;
using std::endl;

class AEvent {

private:

	const Int_t fNPoints;	//!
	Double_t fAmpPos[NCELLS];	//array for raw amplitudes
	Double_t fTime[NCELLS];		//array for raw times
	Double_t fAmpMax;
	Double_t fTimeAmpMax;
	Double_t fAmpCFD[NCELLS];	//array for CFD amplitudes (attenuated, inversed and delayed)
	Double_t fCFD;			//zero-crossing time

	TGraph *gSignal;
	TGraph *gCFD;

	RawEvent *fInputEvent;		//!

public:
	AEvent();
	virtual ~AEvent();
	ClassDef(AEvent,1);

	void SetRawDataFile(const char* inprawfile, const char* treename);
	void ProcessEvent();
//	void Integral()
	void SetInputEvent(RawEvent** event);
	void Reset();
	 //Resets arrays to zeros

	TGraph* GetGraph() {
		return gCFD;
	//	return gSignal;
	}

private:
	void Init();
	void SetGraphs();
	void SetCFD(/*Double_t c = 0.5, Int_t td = 5*/);
};

#endif /* DATACLASSES_AEVENT_H_ */
